#!/bin/env php
<?php
error_reporting(E_ERROR | E_PARSE);

# Handle tar files (possibly gzipped). The first priority is to list
# and extract on the fly. May handle create later.

# list the content of a gzipped tar file
function tarlist($tarname)
{
	$fd = gzopen($tarname, "r");
	while (!gzeof($fd)) {
		$buf = gzread($fd, 512);
		$head = unpack("a100filename/a8mode/a8uid/a8gid/a12size" .
			       "/a12mtime/a8cksum/a1type/a100link" .
			       "/a6magic/a2version/a32user/a32group" .
			       "/a8dmaj/a8dmin", $buf);
		if (!$head[filename] || $head[type] == "5")
			continue;
		$size = octdec($head[size]);
		print "$head[filename] ($size bytes)\n";
		$nb = floor($size / 512);
		$nb += $size % 512 ? 1 : 0;
		for ($i = 0; $i < $nb; $i++)
			$buf = gzread($fd, 512);
	}
}

if ($argc > 1)
	tarlist($argv[1]);
?>
